#include "single_thread.h"
#include <stdio.h>
#include <tangle.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "../jammo.h"
#include "community_utilities.h"
#include "jammosongs.h"
#include "help.h"
#include "jammosounds.h"
#include "discuss.h"

static ClutterContainer *messageList = 0;
GList* messages;
ClutterActor *answerField = 0;
gchar *id;
TextField text;

void start_thread_view(GList* listOfMessages, gchar *id_, gchar *params){

	int i = 0;
	id = id_;
	messages = listOfMessages; 

	puts("starting thread...");
	
	ClutterActor* thread_view = jammo_get_actor_by_id("single-thread-view");
	
	if(thread_view){
	
		clutter_actor_show(thread_view);
		
		if(answerField == 0)
			answerField = jammo_get_actor_by_id("answer-field");
		
		clutter_text_set_text(CLUTTER_TEXT(answerField), "");	

		if(strcmp(id, "jammosongs") == 0){
			text.text = answerField;
			text.lineCount = 8;
			text.handler_id = g_signal_connect_swapped(text.text, "text-changed", (GCallback)limit_line_count, &text);
		

		}else if(strcmp(id, "discuss") == 0){
			text.text = answerField;
			text.lineCount = 8;
			text.handler_id = g_signal_connect_swapped(text.text, "text-changed", (GCallback)limit_line_count, &text);
		
		}	
		
		if(messages != NULL){
		
			messages = g_list_first(messages);
						
			messageList = CLUTTER_CONTAINER(jammo_get_actor_by_id("single-thread-list-scrollable"));
				
			do{	
				if(i > 0){
					messages = messages->next;
				}
				add_message_to_list(messages->data);
				i++;
				
			} while(messages->next != NULL);
		}
			
	}else{
		puts("can't find single-thread-view");
	}

}

void add_message_to_list(gpointer data){

	static int index = 0;
	int MAX = 500;
	//int msg_len = 0;
	
	ClutterActor* messageBackground = 0;
	ClutterContainer *listContainer = CLUTTER_CONTAINER(clutter_group_new());

	struct forum_msg *msg = data;
	
	ClutterColor text_color = { 0, 0, 0, 255 };
	ClutterColor line_color = { 144, 148, 140, 255 };

	ClutterActor* message = clutter_text_new_full("Comic Sans MS 12", msg->msg, &text_color);
	clutter_text_set_line_wrap_mode(CLUTTER_TEXT(message), PANGO_WRAP_WORD_CHAR);

	ClutterActor* avatar = 0;
	ClutterActor* name = clutter_text_new_full("Comic Sans MS 14", msg->sender, &text_color);
	ClutterActor* date = clutter_text_new_full("Comic Sans MS 14", msg->time, &text_color);
	//ClutterActor* avatar_ = clutter_text_new_full("Comic Sans MS 12", msg->avatar, &text_color);

	avatar = clutter_texture_new_from_file("/opt/jammo/communitymenu/community_avatarbackground_small.png", NULL); //this is test avatar
	
	index = (index+1) % 3;

	if(strcmp(msg->title, "") != 0){
		ClutterActor* title = clutter_text_new_full("Comic Sans MS 16", msg->title, &text_color);
		clutter_actor_set_position(title, 80, 10);
		clutter_container_add_actor(listContainer, title);

		clutter_actor_set_position(name, 80, 40); 		
	}else{
		clutter_actor_set_position(name, 80, 20); 
	}
	//msg_len = strlen(msg->msg);

	clutter_actor_set_size(name,((35*10)+30), 41);
	clutter_text_set_max_length(CLUTTER_TEXT(name), 20);
	clutter_container_add_actor(listContainer, name);

	clutter_actor_set_size(date,((20*10)), 20);
	clutter_text_set_max_length(CLUTTER_TEXT(date), 16);
	clutter_actor_set_position(date, 600, 10);
	clutter_container_add_actor(listContainer, date);

	//clutter_actor_set_size(message,(88*7)+40, ((MAX/88)*27));
	clutter_actor_set_width(message, (88*7)+40);
	clutter_text_set_max_length(CLUTTER_TEXT(message), MAX);
	clutter_actor_set_position(message, 80, 80); 
	clutter_container_add_actor(listContainer, message);

	messageBackground = clutter_rectangle_new_with_color(&line_color);
	clutter_actor_set_size(messageBackground, 800, 2);

	int h = (clutter_actor_get_height(avatar) + pango_layout_get_line_count(clutter_text_get_layout(CLUTTER_TEXT(message)))*25);

	/*if(msg_len >= 500){
		clutter_actor_set_position(messageBackground, 0, 230);  

	}else if(msg_len >= 400 && msg_len < 500){
		clutter_actor_set_position(messageBackground, 0, 205); 

	} else if(msg_len >= 300 && msg_len < 400){
		clutter_actor_set_position(messageBackground, 0, 180); 

	} else if(msg_len >= 200 && msg_len < 300){
		clutter_actor_set_position(messageBackground, 0, 160); 

	} else if(msg_len >= 100 && msg_len < 200){
		clutter_actor_set_position(messageBackground, 0, 140); 

	} else {
		clutter_actor_set_position(messageBackground, 0, 120); 
	}*/
	clutter_actor_set_position(messageBackground, 0, h+10);

	clutter_container_add_actor(listContainer, messageBackground);
	
	clutter_actor_set_position(avatar, 10, 1);
	clutter_container_add_actor(listContainer, avatar);

	clutter_container_add_actor(messageList, CLUTTER_ACTOR(listContainer));

}

void add_comment(){

	struct forum_msg *msg;
	time_type tmp;

	clear_container(messageList);
	//clutter_actor_hide(jammo_get_actor_by_id("single-thread-view"));

	msg = malloc(sizeof(message));

	msg->msg = malloc((strlen(clutter_text_get_text(CLUTTER_TEXT(answerField)))+1) * sizeof(gchar));
	strcpy(msg->msg, clutter_text_get_text(CLUTTER_TEXT(answerField)));
	
	// TO-DO: Other fields
	
	strcpy(msg->avatar, "x");
	strcpy(msg->title, "Title");
	strcpy(msg->sender, "Teppo");

	tmp = get_current_time();
	strcpy(msg->time, tmp.time); 

	messages = g_list_append(messages, (gpointer)(msg));

	start_thread_view(messages, id, NULL);

}

void end_single_thread(){

	messages = g_list_first(messages);

	message *temp;

	if(messages != NULL){
		
		temp = (message*)messages->data;
		if(temp->msg != NULL){
			free(temp->msg);
		}
		
		if(messages->data != NULL){
			free(messages->data);
		}
	
		while(messages->next != NULL){
			messages = messages->next;
				
			temp = (message*)messages->data;
			if(temp->msg != NULL){
				free(temp->msg);
				}
				
			if(messages->data != NULL){
				free(messages->data);
				}	
							
		}
	
	}
	clear_container(messageList);
	g_list_free(g_list_first(messages));	


	if( strcmp(id, "help") == 0 ){ 
		start_helpdesk();
	}else if ( strcmp(id, "jammosongs") == 0 ){  
		start_jammosongs();
	}else if ( strcmp(id, "jammosounds") == 0 ){ 
		start_jammosounds();
	}else if ( strcmp(id, "discuss") == 0 ){  
		start_discussionthreads();
	}else{
		//do nothing
	}

}
